package tech.nevets.jaml.gui;

import tech.nevets.jaml.JAML;
import tech.nevets.jaml.Profile;
import tech.nevets.jaml.util.ProfileUtils;
import tech.nevets.jaml.util.Encryptor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.nio.file.Path;

public class NewProfileGui implements Runnable, ActionListener {
    //TODO Formatting
    private JFrame frame;
    private JPanel panel;

    private JTextField profileNameField;
    private JTextField emailField;
    private JPasswordField passwordField;
    private JTextField gamePathField;
    private JTextField versionField;
    private JTextField loaderField;
    private JTextField offlineModeField;

    public void startGui() {
        frame = new JFrame("New Profile");

        JLabel profileNameLabel = new JLabel("Profile Name:");
        profileNameLabel.setBounds(10, 20, 80, 25);
        profileNameField = new JTextField(20);

        JLabel emailLabel = new JLabel("Email:");
        emailLabel.setBounds(10, 50, 80, 25);
        emailField = new JTextField(20);

        JLabel passwordLabel = new JLabel("Password:");
        passwordLabel.setBounds(100, 50, 165, 25);
        passwordField = new JPasswordField(20);

        JLabel gamePathLabel = new JLabel("Game Path:");
        gamePathLabel.setBounds(10, 80, 80, 25);
        gamePathField = new JTextField(20);

        JButton gamePathButton = new JButton("Choose Path");
        gamePathButton.setBounds(200, 80, 25, 25);
        gamePathButton.addActionListener(ae -> {
            JFileChooser fileChooser = new JFileChooser(System.getenv("APPDATA") + "\\.minecraft\\");
            fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            fileChooser.showSaveDialog(null);
            if (fileChooser.getSelectedFile() == null) { return; }
            gamePathField.setText(fileChooser.getSelectedFile().toString());
            fileChooser.setVisible(false);
        });

        JLabel versionLabel = new JLabel("Version:");
        versionLabel.setBounds(100, 80, 165, 25);
        versionField = new JTextField(20);

        JLabel loaderLabel = new JLabel("Loader:");
        loaderLabel.setBounds(10, 110, 80, 25);
        loaderField = new JTextField(20);

        JLabel offlineModeLabel = new JLabel("Offline Mode:");
        offlineModeLabel.setBounds(100, 110, 165, 25);
        offlineModeField = new JTextField(20);

        JButton button = new JButton("Create Profile");
        button.addActionListener(this);

        panel = new JPanel();
        panel.setBorder(BorderFactory.createEmptyBorder(300, 300, 100, 300));
        panel.setLayout(new GridLayout(0, 1));
        panel.add(profileNameLabel);
        panel.add(profileNameField);
        panel.add(emailLabel);
        panel.add(emailField);
        panel.add(passwordLabel);
        panel.add(passwordField);
        panel.add(gamePathLabel);
        panel.add(gamePathField);
        panel.add(gamePathButton);
        panel.add(versionLabel);
        panel.add(versionField);
        panel.add(loaderLabel);
        panel.add(loaderField);
        panel.add(offlineModeLabel);
        panel.add(offlineModeField);
        panel.add(button);

        frame.add(panel, BorderLayout.CENTER);
        frame.setSize(500, 500);
        frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        frame.setTitle("JAML");
        frame.setIconImage(new ImageIcon(JAML.path + "\\assets\\icon.png").getImage());
        frame.pack();
        frame.setVisible(true);
    }

    @Override
    public void actionPerformed(ActionEvent ae) {
        Profile profile = new Profile();
        profile.setProfileName(profileNameField.getText());
        profile.setEmail(emailField.getText());

        if (passwordField.getPassword().length > 0){
            profile.setHashedPassword(Encryptor.encrypt(String.valueOf(passwordField.getPassword())).getData());
            profile.setKey(Encryptor.encrypt(String.valueOf(passwordField.getPassword())).getKey());
            profile.setSalt(Encryptor.encrypt(String.valueOf(passwordField.getPassword())).getSalt());
        }

        profile.setGamePath(Path.of(gamePathField.getText()));
        profile.setVersion(versionField.getText());
        profile.setLoader(loaderField.getText());
        profile.setOfflineMode(Boolean.parseBoolean(offlineModeField.getText()));
        try {
            ProfileUtils.createProfile(profile);
        } catch (IOException e) {
            e.printStackTrace();
        }

        frame.dispose();
    }

    @Override
    public void run() {
        startGui();
    }
}
